// $Id: test-rws.C,v 1.3 2007/12/10 19:23:15 dvermeir Exp $

#include <iostream>
#include "buffer.h"
#include "reader.h"
#include "writer.h"

// Test thread program. The test consists of a reader and a writer
// thread that read/write items to a buffer.
int
main(int,char**) {
  try {
    Buffer  buf; // buffer containing items
    Writer  w(buf,15); // writes items to buffer
    Reader  r(buf,10); // takes items from mbuffer
  
    std::cerr << "reader start.." << std::endl;
    r.start();
    std::cerr << "writer start.." << std::endl;
    w.start();
    // destructors of r, w will cause main thread to wait for r,w to finish
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  return 0;
}
