#ifndef ECHOC_H
#define ECHOC_H
// $Id: echoc.h,v 1.4 2008/11/20 11:14:20 dvermeir Exp $
#include <iostream>
#include <dvnet/socket.h>
#include <dvthread/thread.h>

class EchoClient: public Dv::Thread::Thread {
  public:
    static EchoClient* make(Dv::shared_ptr<Dv::Net::Socket>& so) {
      return new EchoClient(so); 
    } 
    Dv::Net::Socket& so() const { return *so_; }

    friend std::ostream&
      operator<<(std::ostream& os, const EchoClient& echoc);

  private:
    EchoClient(Dv::shared_ptr<Dv::Net::Socket>& so);
    ~EchoClient();
    int main() throw();

    Dv::shared_ptr<Dv::Net::Socket> so_;
};
#endif

