// $Id: threads1.C,v 1.3 2007/12/10 19:23:15 dvermeir Exp $
#include <unistd.h>
#include <string>
#include <iostream>
#include <dvthread/thread.h>

class MyThread: public Dv::Thread::Thread {
  public:
    MyThread(const std::string& msg): msg_(msg) {}
    int main() throw () {
      for (int i=0; i<5; ++i) {
        sleep(1); std::cout << msg_ << std::endl;
      } 
      return 0; 
    }
  private:
    std::string msg_;
};

int
main() {
  MyThread t1("hi"); MyThread t2("ho");
  t2.start(); t1.start(); 
  t1.join(); t2.join(); // wait for threads to finish
}
